import { FieldChangeResult } from "../FieldChangeResult";
import { IChannelsGroup, IChannelsGroupsService } from "./IChannelsGroupsService";
import { IDevice } from "./IDevice";
export declare class ChannelsGroupsService implements IChannelsGroupsService {
    private _serviceName;
    private _connection;
    private _synchronized;
    private _synchronizationTaskCompletionSource;
    constructor();
    GetServiceName(): string;
    WaitForSynchronizationAsync(): Promise<void>;
    ChangeGroupNameAsync(group: IChannelsGroup, name: string): Promise<FieldChangeResult>;
    RemoveGroupAsync(group: IChannelsGroup): Promise<boolean>;
    GetGroupByGuid(guid: string): IChannelsGroup | null;
    GetGroupsAsync(): Promise<IChannelsGroup[]>;
    AddDeviceChannelToGroupAsync(device: IDevice, channel: number, group: IChannelsGroup): Promise<boolean>;
    RemoveDeviceChannelFromGroupAsync(device: IDevice, channel: number, group: IChannelsGroup): Promise<boolean>;
    AddNewGroupAsync(group: IChannelsGroup): Promise<boolean>;
}
