var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { nameof } from "ts-simple-nameof";
import { Api } from "../../Api";
import { DataFrame, Method, Status } from "../../DataFrame";
import { ExalusConnectionService } from "../ExalusConnectionService";
import { SessionService } from "../Session/SessionService";
import { ChannelsGroup } from "./IChannelsGroupsService";
export class ChannelsGroupsService {
    constructor() {
        this._serviceName = nameof(ChannelsGroupsService);
        this._connection = null;
        this._synchronized = false;
        this._synchronizationTaskCompletionSource = null;
        this._connection = Api.Get(ExalusConnectionService);
        this._synchronizationTaskCompletionSource = new Promise((resolve) => {
            Api.Get(SessionService).OnUserLoggedInEvent().Subscribe((user) => __awaiter(this, void 0, void 0, function* () {
                yield this.GetGroupsAsync();
                resolve();
                this._synchronized = true;
            }));
        });
    }
    GetServiceName() {
        return this._serviceName;
    }
    WaitForSynchronizationAsync() {
        return this._synchronizationTaskCompletionSource;
    }
    ChangeGroupNameAsync(group, name) {
        throw new Error("Method not implemented.");
    }
    RemoveGroupAsync(group) {
        throw new Error("Method not implemented.");
    }
    GetGroupByGuid(guid) {
        throw new Error("Method not implemented.");
    }
    GetGroupsAsync() {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new GetGroupsRequest(), 15000, true));
            let groups = [];
            switch (result === null || result === void 0 ? void 0 : result.Status) {
                case Status.OK:
                    (_b = result.Data) === null || _b === void 0 ? void 0 : _b.forEach(group => {
                        let gr = new ChannelsGroup();
                        gr.Guid = group.Guid;
                        gr.Name = group.Name;
                        groups.push(gr);
                    });
                    return groups;
                default:
                    throw new Error(`Failed to get groups, API responded with status ${result === null || result === void 0 ? void 0 : result.Status} data: ${result === null || result === void 0 ? void 0 : result.Data}`);
            }
        });
    }
    AddDeviceChannelToGroupAsync(device, channel, group) {
        throw new Error("Method not implemented.");
    }
    RemoveDeviceChannelFromGroupAsync(device, channel, group) {
        throw new Error("Method not implemented.");
    }
    AddNewGroupAsync(group) {
        throw new Error("Method not implemented.");
    }
}
class GetGroupsRequest extends DataFrame {
    constructor() {
        super();
        this.Resource = "/devices/groups/";
        this.Method = Method.Get;
    }
}
class ApiGroupObject {
    constructor() {
        this.Id = 0;
        this.Guid = "";
        this.Name = "";
    }
}
//# sourceMappingURL=ChannelsGroupsService.js.map