import { IDIService } from "../../IDIService";
import { FieldChangeResult } from "../FieldChangeResult";
import { IDevice } from "./IDevice";
export interface IChannelsGroupsService extends IDIService {
    WaitForSynchronizationAsync(): Promise<void>;
    RemoveGroupAsync(group: IChannelsGroup): Promise<boolean>;
    GetGroupByGuid(guid: string): IChannelsGroup | null;
    GetGroupsAsync(): Promise<IChannelsGroup[]>;
    AddDeviceChannelToGroupAsync(device: IDevice, channel: number, group: IChannelsGroup): Promise<boolean>;
    RemoveDeviceChannelFromGroupAsync(device: IDevice, channel: number, group: IChannelsGroup): Promise<boolean>;
    AddNewGroupAsync(group: IChannelsGroup): Promise<boolean>;
    ChangeGroupNameAsync(group: IChannelsGroup, name: string): Promise<FieldChangeResult>;
}
export interface IChannelsGroup {
    get Guid(): string;
    get Name(): string;
    ChangeNameAsync(name: string): Promise<FieldChangeResult>;
}
export declare class ChannelsGroup implements IChannelsGroup {
    private _guid;
    private _name;
    get Guid(): string;
    set Guid(value: string);
    get Name(): string;
    set Name(value: string);
    ChangeNameAsync(name: string): Promise<FieldChangeResult>;
}
